Bio::AlignIO(3)

NAME
Bio::AlignIO - Handler for AlignIO Formats

SYNOPSIS
    use Bio::AlignIO;
    $inputfilename = "testaln.fasta";
    $in  = Bio::AlignIO->new(-file => $inputfilename , '-format' => 'fasta');
    $out = Bio::AlignIO->new(-file => ">out.aln.pfam" , '-format' => 'pfam');
    # note: we quote -format to keep older perl's from complaining.
    while ( my $aln = $in->next_aln() ) {
        $out->write_aln($aln);
    }
or

    use Bio::AlignIO;
    $inputfilename = "testaln.fasta";
    $in  = Bio::AlignIO->newFh(-file => $inputfilename , '-format' => 'fasta');
    $out = Bio::AlignIO->newFh('-format' => 'pfam');
    # World's shortest Fasta<->pfam format converter:
    print $out $_ while <$in>;

DESCRIPTION
Bio::AlignIO is a handler module for the formats in the AlignIO set (eg, Bio::AlignIO::fasta). It is the officially sanctioned way of getting at the alignment objects, which most people should use.

The idea is that you request a stream object for a particular format. All the stream objects have a notion of an internal file that is read from or written to. A particular AlignIO object instance is configured for either input or output. A specific example of a stream object is the Bio::AlignIO::fasta object.

Each stream object has functions

   $stream->next_aln();
and

   $stream->write_aln($aln);
also

   $stream->type() # returns 'INPUT' or 'OUTPUT'
As an added bonus, you can recover a filehandle that is tied to the AlignIO object, allowing you to use the standard <> and print operations to read and write sequence objects:

    use Bio::AlignIO;
    $stream = Bio::AlignIO->newFh(-format => 'Fasta'); # read from standard input
    while ( $aln = <$stream> ) {
        # do something with $aln
    }
and

    print $stream $aln; # when stream is in output mode
This makes the simplest ever reformatter

    #!/usr/local/bin/perl
    $format1 = shift;
    $format2 = shift || die "Usage: reformat format1 format2 < input > output";
    use Bio::AlignIO;
    $in  = Bio::AlignIO->newFh(-format => $format1 );
    $out = Bio::AlignIO->newFh(-format => $format2 );
    #note: you might want to quote -format to keep older perl's from complaining.
    print $out $_ while <$in>;
AlignIO.pm is patterned on the module SeqIO.pm and shares most the SeqIO.pm features. One significant difference currently is that AlignIO.pm only handles IO for a single alignment at a time (SeqIO.pm handles IO for multiple sequences in a single stream.) The principal reason for this is that whereas simultaneously handling multiple sequences is a common requirement, simultaneous handling of multiple alignments is not. Capability for IO for more than one multiple alignment (which may be of use for certain applications such as IO for Pfam libraries) may be included in the future. For this reason we keep the name "next_aln()" for the alignment input routine, even though currently only one alignment is read (or written) at a time and the name "read_aln()" might be more appropriate.

CONSTRUCTORS

  Bio::AlignIO->new()
   $seqIO = Bio::AlignIO->new(-file => 'filename',   -format=>$format);
   $seqIO = Bio::AlignIO->new(-fh   => \*FILEHANDLE, -format=>$format);
   $seqIO = Bio::AlignIO->new(-format => $format);
The new() class method constructs a new Bio::AlignIO object. The returned object can be used to retrieve or print BioAlign objects. new() accepts the following parameters:

-file
    A file path to be opened for reading or writing. The usual Perl conventions apply:

       'file'       # open file for reading
       '>file'      # open file for writing
       '>>file'     # open file for appending
       '+<file'     # open file read/write
       'command |'  # open a pipe from the command
       '| command'  # open a pipe to the command

-fh You may provide new() with a previously-opened filehandle. For example, to read from STDIN:

       $seqIO = Bio::AlignIO->new(-fh => \*STDIN);
    Note that you must pass filehandles as references to globs.

    If neither a filehandle nor a filename is specified, then the module will read from the @ARGV array or STDIN, using the familiar <> semantics.

-format
    Specify the format of the file. Supported formats include:

       fasta       FASTA format
       pfam        pfam format
       selex       selex (hmmer) format
       stockholm   stockholm format
       prodom      prodom (protein domain) format
       clustalw    clustalw (.aln) format
       msf         msf (GCG) format
       mase        mase (seaview) format
    Currently only those formats which were implemented in SimpleAlign.pm have been incorporated in AlignIO.pm. Specifically, mase, stockholm and prodom have only been implemented for input. Clustalw format has only been implemented for output.

    If no format is specified and a filename is given, then the module will attempt to deduce it from the filename. If this is unsuccessful, Fasta format is assumed.

    The format name is case insensitive. 'FASTA', 'Fasta' and 'fasta' are all supported.

  Bio::AlignIO->newFh()
   $fh = Bio::AlignIO->newFh(-fh   => \*FILEHANDLE, -format=>$format);
   $fh = Bio::AlignIO->newFh(-format => $format);
   # etc.
This constructor behaves like new(), but returns a tied filehandle rather than a Bio::AlignIO object. You can read sequences from this object using the familiar <> operator, and write to it using print(). The usual array and $_ semantics work. For example, you can read all sequence objects into an array like this:

  @sequences = <$fh>;
Other operations, such as read(), sysread(), write(), close(), and printf() are not supported.

OBJECT METHODS
See below for more detailed summaries. The main methods are:

  $alignment = $AlignIO->next_aln()
Fetch an alignment from a formatted file.

  $AlignIO->write_aln($aln)
Write the specified alignment to a file..

  TIEHANDLE(), READLINE(), PRINT()
These provide the tie interface. See the perltie manpage for more details.

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to one of the Bioperl mailing lists. Your participation is much appreciated.

  bioperl-l@bioperl.org               - General discussion
  http://bio.perl.org/MailList.html   - About the mailing lists

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track
 the bugs and their resolution.
 Bug reports can be submitted via email or the web:

  bioperl-bugs@bio.perl.org
  http://bio.perl.org/bioperl-bugs/

AUTHOR - Peter Schattner
Email: schattner@alum.mit.edu

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  new
 Title   : new
 Usage   : $stream = Bio::AlignIO->new(-file => $filename, -format => 'Format')
 Function: Returns a new seqstream
 Returns : A Bio::AlignIO::Handler initialised with the appropriate format
 Args    : -file => $filename
           -format => format
           -fh => filehandle to attach to

  newFh
 Title   : newFh
 Usage   : $fh = Bio::AlignIO->newFh(-file=>$filename,-format=>'Format')
 Function: does a new() followed by an fh()
 Example : $fh = Bio::AlignIO->newFh(-file=>$filename,-format=>'Format')
           $sequence = <$fh>;   # read a sequence object
           print $fh $sequence; # write a sequence object
 Returns : filehandle tied to the Bio::AlignIO::Fh class
 Args    :

  fh
 Title   : fh
 Usage   : $obj->fh
 Function:
 Example : $fh = $obj->fh;      # make a tied filehandle
           $sequence = <$fh>;   # read a sequence object
           print $fh $sequence; # write a sequence object
 Returns : filehandle tied to the Bio::AlignIO::Fh class
 Args    :

  _load_format_module
 Title   : _load_format_module
 Usage   : *INTERNAL AlignIO stuff*
 Function: Loads up (like use) a module at run time on demand
 Example :
 Returns :
 Args    :

  next_aln
 Title   : next_aln
 Usage   : $aln = stream->next_aln
 Function: reads the next $aln object from the stream
 Returns : a Bio::Seq sequence object
 Args    :

  write_aln
 Title   : write_aln
 Usage   : $stream->write_aln($aln)
 Function: writes the $aln object into the stream
 Returns : 1 for success and 0 for error
 Args    : Bio::Seq object

  close
 Title   : close
 Usage   : $seqio->close()
 Function: Closes the file handle associated with this seqio system
 Example :
 Returns :
 Args    :

  _print
 Title   : _print
 Usage   : $obj->_print(@lines)
 Function:
 Example :
 Returns : writes output

  _readline
 Title   : _readline
 Usage   : $obj->_readline($newval)
 Function:
 Example :
 Returns : reads a line of input

  _filehandle
 Title   : _filehandle
 Usage   : $obj->_filehandle($newval)
 Function:
 Example :
 Returns : value of _filehandle
 Args    : newvalue (optional)

  _guess_format
 Title   : _guess_format
 Usage   : $obj->_guess_format($filename)
 Function:
 Example :
 Returns : guessed format of filename (lower case)
 Args    :